
	ORG 32768
	di
	jr				skipflags
	
pixel_coordinates:
pixel_coordinate_x:
					defb	2						; rightwards direction
pixel_coordinate_7:									; these are set up by BC
					defb	8						; downwards direction
linespacing:		defb	12
left_margin: 		defb    8
right_margin: 		defb    255
paragraphtab:		defb    20

score:				defw	0			;number of times we have scrolled
clive:				defb    128			;position on the screen in pixels
linecountdown:      defb    30			;how long til next line (starts at 0)
thruthetext:		defw	textdata	;how far through the text we are

skipflags:

												; print the length of the routine
					;	ld		bc,endofdata

					;	call 	11563          ; stack number in bc.
       				;	call 	11747          ; display top of calc. stack.
		    	    ;	ret     38046

					; jp		testingthings
				
					; score = 2306 is the end.
				


					call menu		;instructions and menu

		


startagame:
;---------------------------------------------------------------------------------
;set_up_the_screen, including border and the stream
;---------------------------------------------------------------------------------
set_up_the_screen:
                        ld      a,2              ; Initially printing to the Upper screen
                        call    5633             ; Open channel
                        ld      a,7              ; 1 is the code for blue
                        call    8859             ; set border colour.
                        ld      a,8*7+7          ; white ink, white paper
                        ld      (23693),a        ; set our screen colours.
                        call    3503             ; clear the screen.
                        
                        ld      a,8*7+0         ; black ink, white paper
                        ld      (23693),a        ; set our screen colours.
                        
						ld      hl,22528+64+1
						ld		b,22
nextln:					ld      c,30
nextsqr:				ld		(hl),8*7+0		; white paper, black ink
						inc		hl
						dec		c
						jr		nz,nextsqr
						inc		hl
						inc		hl
						dec		b
						jr		nz,nextln
						
						call	screenflash		; set up the colourbars


;---------------
;print the last score, if there was one
;----------------

						ld		bc,(score)		; check the last score was zero.  2306 if you finished the game.
						xor		a
						or		b
						or		c
						jr		z,noprint	   ; skip the following if previous score is zero (I.e. first go)
											   ; otherwise
						ld		de,22			; 2200 was 'complete'		   
						call	div_bc_de		; divide bc by (de divided by 100) (how far through were you)		   
												; this'll do as the percentage
											   
						call 	11563          ; stack number in bc.  
						
						ld		a,4
						ld		(fontdata),a
						ld		hl,gotthrough
						ld		bc,9050h
						ld		(pixel_coordinates),bc
						call	prop_string
						 
						ld		a,22		   ; at 18,25
						rst 	16
						ld		a,18
						rst		16
						ld		a,25
						rst		16
						ld		a,16			; ink 0
						rst		16	
						ld		a,0				
						rst     16
       					call 	11747           ; display top of calc. stack.	
       					ld		a,"%"
       					rst     16
       					
    sound_setup:						;"qukkkkk" sound, when you've hit something
		ld de, 5						; from a SC thread about sfx, contributed by forum member Morkin
		ld b,3
		ld hl, 938 						; pitch
	sound_loop:
		dec h
		push bc
		push de
		push hl
		call 949 						; call ROM beeper routine
		pop hl
		pop de
		pop bc
		djnz sound_loop

       					
noprint:										; jump to here if we don't want to print a score from before

;---------------
;reset the variables for the next game
;----------------

						ld	hl,0					;reset variables for a new playthru
						ld	(score),hl
						ld	a,30
						ld 	(linecountdown),a
						ld	hl,textdata
						ld	(thruthetext),hl
						ld	a,128
						ld	(clive),a
						ld  a,16
						ld	(changesmc+1),a		;reset the movement
						ld	a,64
						ld	(linespacesmc+1),a	;reset the linespaceing
						
;-----------------------------------
;Print the next bit of Alan's Letter
;-----------------------------------
messageprint:						
						;ld		bc,(score)
						;call 	11563          ; stack number in bc.
       					;call 	11747          ; display top of calc. stack.						
						
						
						ld		hl,(score)		;how far through are we
						rlc		l
						rl		h
						ld		a,h				;(increases every 128)
						and      %11111000		; is it bigger than the minimum
						jr		nz,minimumwidth
						ld		a,h
						and		%111
						sub		7
						jr		z,minimumwidth						
						neg
						ld      (fontdata),a		;set the 'space' width to be that
						jr		widthset
minimumwidth:
						ld      a,3
						ld		(fontdata),a						
widthset:						
						ld		bc,0x0208
						ld		(pixel_coordinates),bc
						ld		hl,(thruthetext)		;load the next string
						call	prop_string

						cp		255
						jp		z,finished		; finished

						inc		hl
						ld		(thruthetext),hl		;returns with HL pointing at the 0

keyloop:						
						ld bc,57342         ; YUIOP
 					  	in a,(c)            ; see what keys are pressed.
 					  	rra                 ; outermost bit = key 1. P
       					push af             ; remember the value.
       					call nc,MOVERIGHT   ; it's being pressed, move RIGHT. P
						pop	af
						rra
						push af
       					call nc,MOVELEFT   ; it's being pressed, move LEFT. O
       					pop af
						rra
						push af
						
						ld	hl,(score)	; increment the score
						inc	hl
						ld	(score),hl
						
       					call SCROLL   		; (regardless of keypress) call the scroll routine
       					call changeposition	; change the pixel position
       					call PLOTCLIVE		; draw the pixel on the screen

       					pop af						
					
						;rra					; check if U is being pressed		
						
						;jr	nc,quittobasic				; QUIT if U is being pressed
						
						ld  hl,linecountdown
						ld	a,(hl)
						inc a
						ld  (hl),a
						
linespacesmc:			cp  64               ; is it time for a new line (this'll go down)
						
						jr  nz,keyloop						

						ld	(hl),0			; reset the linecountdown
						ld  hl,linespacesmc+1
						dec (hl)
						
						jr messageprint

						;ret	
quittobasic:			
						ei
						ret


;----------------------------------------------
;Draw the pixel at the top of the squiggly line
;----------------------------------------------
PLOTCLIVE:
						ld   a,(clive)
						and %11111000
						rra	
						rra
						rra
						ld	 l,a						
						ld   h,50h
						ld	a,(hl)
						ld	c,a			;store current contents
						ld   a,(clive)
						and  %111
						inc a
						ld   b,a
						xor a
						scf
pixelpick:									; push it in the right number of pixels
						rra
						djnz	pixelpick
						
						ld		b,a		; store it temporarily												
						or 		c		; merge with current contents
						ld		c,a		; store THAT temporarily
						
						ld  	a,(hl)	; get the old screen
						xor		b		; rather than or
						cp      c		; are they the same? if not "CRASH"
						ld   	(hl),a	; write to the screen
						jp 		nz,crash
						ret					

crash:					ld bc,65278         ; keyboard row caps,z,x,c,v
     			 		in a,(c)            ; see what keys are pressed
     			 		and %00000110		; just interested in Z and X
     			 		ret z         		;  return normally if Z and X are both being pressed.	[<<<< CHEAT MODE]
     			 		pop 	hl			; clear the stack
     			 		pop		hl			;
						jp	startagame

changeposition:
						ld   hl,clive
changesmc:				ld	 a,16		;this will change 0-32
						cp	15
						jr	z,halfangle
						cp	18
						jr	z,halfangle
returntohere:			or	a			; clear carry flag
						rra				; halve it (0-16)
						sub  8			; take away 8 ... so -8 to 8
						add  a,(hl)		; add this to position
						ld	(hl),a		; re-store the position
						
									 	;is it on the play area
						cp   8			
						jr	c,bounceoffwalll		; a<8 then bounce
						cp   248
						jr  nc,bounceoffwallr	; a>=248
						ret

halfangle:				ld	a,(score)		;lets only move half the time
						bit	0,a				;opposite of bit 0 goes into Z flag
						ld	a,(changesmc+1)	;resetwhatthechangeis
						jr	z,returntohere
						ld 	a,16
						jr	returntohere

bounceoffwalll:									; bounce off the left wall
						ld	a,8
						ld  (clive),a
						jr bounceoffwall

bounceoffwallr:									; bounce off the right wall
						ld	a,247
						ld  (clive),a
						jr bounceoffwall

bounceoffwall:									; flips direction of travel
						ld	a,(changesmc+1)
						sub 32
						neg
						inc a
						ld	(changesmc+1),a
						ret


MOVERIGHT:				ld  a,(changesmc+1)
						inc a
						cp  32
						ret z
						ld  (changesmc+1),a
						ret

MOVELEFT:				ld  a,(changesmc+1)
						dec a
						cp  0
						ret z
						ld  (changesmc+1),a
						ret
												
					
MOVERIGHT1:				ld  hl,clive
						ld	a,(hl)
						inc a
						ld  (hl),a
						ret
MOVELEFT2:				ld  hl,clive
						ld	a,(hl)
						dec a
						ld  (hl),a
						ret
dosomething:
						ret

;---------------
;Alan's letter
;---------------

textdata:
						defb   "7th April 1986.",0

						defb	"Sir Clive,",0
						defb	"      From the desk of ALAN 'Sweet-As' SUGAR.",0
						defb	"I am delighted to offer for you a sum of `4.99",0
						defb	"for your failing company. ...the one called ",22h,"SINCLAIR",22h,".",0
						defb    "(Which is not only vain, but also sounds like an ickle-",0
						defb	"-girly name.  ",22h,"CLAIR",22h," indeed!   Real men use INITIALS",0
						defb	"in their company name.  Like I did.)",0
						defb	"Now, we're gonna be bolting a cassette player onto the",0
						defb	"edge of your old computer, to make it more CPCish.  It",0
						defb	"will be a SUREFIRE hit with the kids.  I'm down with 'da kids'",0
						defb    "'cos I've sold hooky-goods from a van.   On a market-stall",0
						defb	"down Camden high-street.       I was doin' that while eggheads",0
						defb	"like you were getting swotting up  ...  practicing for all those",0
						defb	"those I.Q. and MESNSA tests.",0
						defb	"                         My Plan...",0
						defb	"We'll sell your old rubbish to the public.     Plus my",22h,"datacorder",22h,0
						defb	"then maybe some mugs will mistakenly assume it's special",0
						defb	" ...and better than the separate tape player from ",22h,"TANDY",22h,0
						defb	"that they've been using previously.",0
						defb    "                                                              (Suckers!!!!)",0
						defb	"...which means ``` for me.",0
						defb	"Now, let's get on to the tricky matter of BEARDS.",0
						defb	"...Mine is SUPERIOR.  And my AFRO beats your chrome dome",0
						defb	"hands down.  I want a clause explicit in this purchase that",0
						defb	"makes",25," you ",26,"publicly ",27,"acknowledge ",19,"that ",18,"I ",17,"would WIN in ANY &",0
						defb	"ALL 'facial hair battles' that we could partake in.",0
						defb	"So will you sign on the dotted line?   Eh?  You should if you",0
						defb    "know what's good for you.    'Cos I know some right tasty",0
						defb	"geezers.  You don't wanna mess with BIG ALAN, Clive - let",0
						defb	"me assure you of that!",0
						defb	"What do you say then - `4.99.  For all future use of your",0
						defb	"computer and of your name, and all future wives you might",0
						defb	"marry.  Hahaha.  As if you'll ever have kind of gal I like!",0
						defb	"I prefer lap-dancer-types to the bookworms that you are ",0
						defb	"used to, I'll bet!",0
						defb	"Now - the nitty gritty.  You must never use your own name",0						
						defb	"to sell whatever whacky thing you come up with next!    It",0
						defb	"will be some kind of crackpot inventor stuff.  Not a normal",0
						defb	"idea plus a cassete deck.  That's my schtick!  You did try",0						
						defb	"with the Q.L.             ... but then bolted on a MICRODRIVE!",0
						defb	"Punters were never gonna want that.   Why don't you build",0						
						defb	"tiny things?  Like your mini T.V.  THAT did well... NOT.  Maybe",0
						defb	"you can make little radios that fit inside your earholes, or",0						
						defb	"some-such guff!  Why don't you make tiny kiddy cars?  Ha!",0
						defb	"So - `4.99 then ... - I can SEE FIVE quid would be of help",0						
						defb	"to you as you're clearly up the creek financially.",0
						defb	"So, mush, shake my hand and we'll call it a deal!   You can",0						
						defb	"get back to your laboratory whilst I put my thinking cap on",0
						defb	"and see how I can use your old computer.   I know!    I've",0
						defb	"got it!  I'm a genius!  I'll make ANOTHER version but add",0						
						defb	"a proper disk drive, like I did with my computer last year.",0
						defb	"It'll take weird floppies, that IBM will decided not to use!",0						
						defb	"Then, later on, maybe I'll put your computer inside a phone",0
						defb	"along with a ",25," black ",17,"and",25," white",17," screen.  It'll make a mockery",0	
						defb	"of the ",22h,"Spectrum",22h," name!",0
						defb	"                                                    MWA HA HA HA HA!",0						
						defb	"          So come on 'Uncle' Clive... sign here",0
						defb	" ",0						
						defb	" ",0						
						defb	". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .",0
						defb    13,0,13,0,13,0,13,0


						defb 255

;---------------------------------------------------
;Other messages (Title Page, and Congratulations)
;-------------------------------------------------					
			
INSTRUCTIONS:			
						defb	"SIR CLIVE'S INK LAIR",14
						defb	14,"SINCLAIR is in financial trouble.  The year is 1986",14
						defb	"and the launch of your new business oriented computer",14
						defb	"has been a disaster.",14
						defb	14,"You, Clive Sinclair, have to navigate your way",14
						defb	"through all of the legalease nonsense sent to you",14
						defb	"by your arch rival.  But don't get caught up in the",14
						defb	"words!  Your eyes must dodge them, but still pretend",14
						defb	"to be reading by never letting them leave the page",14,14
						defb	"Use the keys 'O' and 'P' to dodge the words and save",14
						defb	"your company!",14,14
						defb	15,15,"           PRESS 'QL' to start."	

						defb	0
	
CONGRATS:			
						defb	"CONGRATULATIONS!",14
						defb	14,"YOU HAVE ESCAPED SIR CLIVE'S INK LAIR, and saved",14
						defb	"the fate of the ZX SPECTRUM from the evil clutches",14
						defb	"of ALAN SUGAR.",14
						defb	14,"Now you are free to fulfil your whims, and make",14
						defb	"teeny-tiny vehicles for 14 year olds, and slightly",14
						defb	"embarrassing bicycles with teeny-tiny wheels.",14
						defb	"(While Alan becomes a TV star and a 'Lord')",14,14
						defb	"Enjoy your birthdays, and continue to make people",14
						defb	"marvel at your bonkers ideas as you grow old!",14
						defb	14,14
						defb	15,15,"          PRESS 'CPC' to QUIT."	
						defb	0						

gotthrough:				defb	"Last time you completed:",0


;------------------------
;ending screen (congrats)
;------------------------

finished:
                        ld      a,2              ; Initially printing to the Upper screen
                        call    5633             ; Open channel
                        ld      a,7              ; 1 is the code for white
                        call    8859             ; set border colour.
                        ld      a,8*7+0          ; white ink, blue paper
                        ld      (23693),a        ; set our screen colours.
                        call    3503             ; clear the screen.

					ld  bc,0158h
					ld	(pixel_coordinates),bc

					ld	hl,CONGRATS
					call prop_string
					
					call screenflash

waitforCPC:
					ld	bc,57342  		; keys YUIOP
					in a,(c)            ; see what keys are pressed.
       				rra	
       				jr	c,waitforCPC		; if P isn't pressed jumpback
  					ld	bc,65278	 		; 65278 V, C, X, Z, Caps Shift	
					in a,(c)            ; see what keys are pressed.
       				rra	
       				rra
       				rra
       				rra
       				jr	c,waitforCPC	; if L isn't pressed jumpback     				
       				   
					jp   quittobasic	;for now



;----------------------------------------
; titlepage (when you first run the game)
;-----------------------------------------


menu:

                        ld      a,2              ; Initially printing to the Upper screen
                        call    5633             ; Open channel
                        ld      a,7              ; 1 is the code for white
                        call    8859             ; set border colour.
                        ld      a,8*7+0          ; white ink, blue paper
                        ld      (23693),a        ; set our screen colours.
                        call    3503             ; clear the screen.

					ld  bc,0150h
					ld	(pixel_coordinates),bc

					ld	hl,INSTRUCTIONS
					call prop_string
					
					call screenflash
					
waitforql:
					ld	bc,64510  		; keys QWERT
					in a,(c)            ; see what keys are pressed.
       				rra	
       				jr	c,waitforql		; if Q isn't pressed jumpback
  					ld	bc,49150 		; keys ENT,L,K,J,H		
					in a,(c)            ; see what keys are pressed.
       				rra	
       				rra
       				jr	c,waitforql		; if L isn't pressed jumpback     				
       				   
					ret
					
					
;----------------------------------------------------------------
;Prints a string, addressed by HL, deals with some CTRL codes too
;----------------------------------------------------------------

prop_string:
prop_string_loop:
						ld      a,(hl)
						or		0				; END OF String?
						ret		z
						cp		255				; End of String (alternate)
						ret		z
						push	hl				; save the pointer
						cp      32				; is the character a ctrl code?
												; If A < N, then C flag is set.
						jr		c,ctrlcode						
						bit     7,a				; is the character > (c)
						jr		z,ready_to_print	;if not, print it
												; if so, then Kern left, by 1
						ld		hl,pixel_coordinate_x
						dec		(hl)			; pushed them closer together, by 1
						and		%01111111		; ignore the highest bit (the flag)
ready_to_print:						
						call	proportional_print_character		
next_character_in_prop_string:						
						pop		hl
						inc 	hl
						jr		prop_string_loop						
ctrlcode:										
						
						cp      13							;
						jr		nc,over12									
						ld		hl,(pixel_coordinate_x)		; 1 to 12 move cursor 1-12 pixel right
						add		a,l
						ld		(pixel_coordinate_x),a						
						jr		next_character_in_prop_string						
over12:
						jr		nz,over13					; 13 is carriage return, is it that?
carriagertn:
						ld		bc,(pixel_coordinates)		; if so, we can use
						call	out_of_screen				; same routine as print uses
						jr		next_character_in_prop_string
over13:						
						cp		15							; 14 new paragraph
						jr		nc,over14					; 15 new tab position
						ld		bc,(pixel_coordinates)		; tab is like new line
						call	out_of_screen				; same routine as print uses
						ld      a,(paragraphtab)			
						ld		c,a
						ld      (pixel_coordinates),bc
						jr		next_character_in_prop_string
over14:					jr		nz,over15
						ld		a,(pixel_coordinate_x)
						or      %111111
						inc     a
						jr      z,carriagertn				; if it would be off screen, use a Carriage rtn.
						ld		(pixel_coordinate_x),a
						jr		next_character_in_prop_string
over15:					cp		16							; move back a pixel on CHR$16
						jr      nz,upanddownrows
						ld		bc,(pixel_coordinates)
						dec		c
						ld		(pixel_coordinates),bc				
						jr		next_character_in_prop_string					
upanddownrows:			ld		b,a
						and     %111 						; a  = 0 to 7					
						ld		c,a							; store l
						ld		a,b
						and		%11000
						cp		16
						ld		a,c
						jr		z,lineup
					;	cp		24
						jr      linedown

lineup:					neg
linedown:				
						ld		bc,(pixel_coordinates)
						add		a,b
						ld		(pixel_coordinates+1),a
						jr		next_character_in_prop_string				
															; 17,18,19,20,21,22,23 = up 1,2,3,4,5,6,7
															; 25,26,27,28,29,30,31 = down 1,2,3,4,5,6,7
															
offscreen:	scf					; just clear the carry flag, and jumpback to routine
			ccf					; where it'll call the 'new line'
			jr	offscreen2

;------------
;Proportional Printing Routine
;LETS KEEP THIS .... SMALL and QUICK
;------------

proportional_print_character:	;print a character in A register, at 'pixel coordinates'
			ld      hl,fontdata-32*8
			ld      e,a
			ld      d,0
			RlC		e
			rl		d
			rl		e
			rl		d
			rl		e
			rl		d   		; multiply DE by 8
			add		hl,de		; HL now points at the data for character
			ld		a,(hl)		; the data byte
			and		1111b		; just the width (0-9, normally)			
			ld		bc,(pixel_coordinates)	; get the pixel co-ordinates for printing
			add		a,c			; will it be 'off the screen' when printed (assumes the RIGHT most pixel is blank.  Might not be- but up to font designer to have correctly set this)
			jr      c,offscreen
			ld		de,(right_margin)
			cp		e 		    ; custom maximum width
offscreen2:	call	nc,out_of_screen				; if it would end up off the screen
			ld		d,b
			ld		e,a
			push	de			; de has the print position *after* this is printed, store it away
						
			ld		(choosesprite_smc+1), HL
			ld		a,(hl)		; the data byte, again
			and		%11110000   ; is the a vertical shift? 
			jr		z,noverticalshift
			rra
			rra
			rra
			rra					; move it into the 'shift' position
			ld		e,a			; store a, to check whether it'll be + or -
			and		%111		; keep just the lowest three bits of a
			bit 	3,e			; test whether it is up or down
			jr		nz,addshift	; downward, if bit 7 (now 3) was unset	
			neg					; negate A
addshift:	add		a,b
			ld		b,a			
			
noverticalshift:			
			call    SPRITE		; print sprite at HL, at position BC
			
			pop		bc			; restore the print position after this, into BC
			ld		(pixel_coordinates),bc ; store the updated pixel coordintates			

			ret					; return from my print routine
out_of_screen:		            ; called if the character will take us off the right of the printable area
			ld		a,(left_margin)
			ld		c,a
			ld		a,(linespacing)	   ; custom height
			add		a,b
			ld		b,a
			ld		(pixel_coordinates),bc
			ld		a,(hl)
			and		1111b		; a contains new x co-ordinate (width)
			add     a,c			; add this to c, to give the next co-ordinate
			ret
SPRITE:
;------------------------------------------------------
;A print a Character at the pixel location B,C routine
;------------------------------------------------------
	ld a,b			; Work on the upper byte of the address
	and %00000111	; a = Y2 Y1 y0
	or %01000000	; first three bits are always 010
	ld h,a			; store in h
	ld a,b			; get bits Y7, Y6
	rra				; move them into place
	rra				;
	rra				;
	and %00011000	; mask off
	or h			; a = 0 1 0 Y7 Y6 Y2 Y1 Y0
	ld h,a			; calculation of h is now complete
	ld a,b			; get y
	rla				;
	rla				;
	and %11100000	; a = y5 y4 y3 0 0 0 0 0
	ld l,a			; store in l
	ld a,c			;
	
	ld e,a			; save the lowest bits
	and %11111000	; a = X4 X3 X2 X1
	rra
	rra
	rra
	or l			; a = Y5 Y4 Y3 X4 X3 X2 X1
	ld l,a			; calculation of l is complete
	
	ld	a,e			; restore the lowest bit (pixel position)
	and	7			; just the pixel position

		LD (SCRADD),HL  ; store the screen address for later
		LD (BITPOSsmc+1),A		; know how many times to shift the sprite data
choosesprite_smc:
		LD HL,0000		; start address for the sprite graphic		;smc'd
		inc	hl
		LD C,7			; The sprite is 8 lines tall

LINELOOP	
		LD E,(HL)		; load the E reg with the first line of
		INC L			; sprite data, and move forward			; now boundary doesn't matter

		PUSH HL			; preserve this address for later
BITPOSsmc
		LD A,0			; Retrieve the pixel position
		OR A			; Quick way of testing if A is zero - Note: A is unaffected
		JR Z,SKIPROTATE	; If zero then no shifting is needed

		LD B,A			; loop counter for number of times to
						; rotate (shift) sprite data
		XOR A			; Quick way setting A to zero and
						; clearing the Carry Flag. The Carry Flag must be reset
						; as the rotate instructions will shift its contents
						; into the sprite data.

ROTATELOOP	RR E		; An extra register is needed for the
		RRA				; shifted sprite data. After the RR E is executed
						; rightmost bit of sprite data is shifted out to the Carry Flag.
						; It is then shifted into the A reg by RRA. So no data is lost.
		DJNZ ROTATELOOP	; Loop back until shifting is complete

SKIPROTATE	LD D,A		; Store in D register, as A will be
						; needed for another purpose. E & D regs now contain the
						; shifted sprite data.
	
		LD HL,(SCRADD)	; Get back the screen address

		LD A,(HL)		; Actually put a line of the sprite on the screen
		XOR E			
		LD (HL),A
		INC L
		LD A,(HL)
		XOR D
		LD (HL),A

		DEC L			; move back and down one line
		INC H

		LD A,H			; It is not necessary to recalculate
		AND 7			; the screen address for each line of
		JR NZ,A1		; the sprite. All that is needed is to
		LD A,L			; check if a char. or segment boundary
		ADD A,32		; has been crossed and adjust address
		LD L,A			; accordingly.
		JR C,A1
		LD A,H
		SUB 8
		LD H,A

A1		LD (SCRADD),HL	; store it again

		POP HL		   ; retrieve the address of the next line
					   ; of sprite data
		DEC C		
		JP NZ,LINELOOP	; loop back until all lines are drawn.

		RET

SCRADD	DEFW 0








						


SCROLL:				; scroll the screen down one pixel line


	ld hl,5800h-2	; lets ignore the outer two character squares
scrollloop:
	push hl
	pop de	


MOVEALINEDOWN:		; this routine - to get to 'next line' on screen was contributed to SC forums by ast.a.more
	ld a,h			;check if were within 7 bottom lines of a char row
	and 7			;one of the three lowest bits will not be 0
	jr nz,done		;if so, it is safe to decrement H and move one line up
	ld a,l			;else, load A with L
	sub $20			;subtract 32 from it,
	ld l,a			;and put it back in L
	jr c,done		;if SUB $20 results in an overflow, were on the next line up
					;of char row
	ld a,h
	add a,8			;now add 8 to H
	ld h,a			;to move to the next char row
done	dec h		;move up one line


	ld a,3Fh
	cp h
	ret z
	
	push hl
	ldd				; not quickest way, probably, but quick enough
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd	
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd
	ldd

	pop hl
	jr scrollloop


screenflash:		;set up the colourflash
	ld		c,8
	ld		de,5000h+31
	ld		hl,flashdata
flashlp:
	push	de

	ld		b,8
flashloop2:
	ld		a,(hl)
	ld		(de),a
	inc		hl
	inc		d
	djnz	flashloop2
	pop		de
	ld		a,e
	add		a,32
	ld		e,a
	dec 	c
	jr		nz,flashlp
	
	ld		hl,colourdata
	ld		de,5affh-32*7		;end of attributes
	ld		b,8
colourloop:
	ld		a,(hl)
	ld		(de),a
	inc		hl
	ld		a,e
	add		a,32
	ld		e,a
	djnz	colourloop
	
	ret
	
flashdata:
	defb	0,0,0,0,255,0,0,255
	defb	0,255,0,255,0,255,255,0
	defb    255,255,255,0,255,255,255,255
	defb	255,254,252,248,240,224,192,128
	defb	255,254,252,248,240,224,192,128
	defb	255,254,252,248,240,224,192,128
	defb	255,254,252,248,240,224,192,128
	defb	255,254,252,248,240,224,192,128

colourdata:
	defb	7*8+0,7*8+0,7*8+0,2*8+0,6*8+2,4*8+6,5*8+4,0*8+5
	;red,yellow,green,cyan,black



testingthings:
				
				ld		de,6
				ld		bc,100
				ld		a,b
       				
;----------------------------------------------
; PRINT THE PERCENTAGE THROUGH ON THE LAST PASS
;----------------------------------------------
       				
;The following routine divides bc by de and places the quotient in bc and the remainder in hl

div_bc_de:
					ld	a,b
				    ld	hl, 0
				    ld	b, 16

_loop:
		   			sll	c
 		 	 		rla
					adc	hl, hl
					sbc	hl, de
					jr	nc, $+4
					add	hl, de
					dec	c
   
 					djnz	_loop
   
   					ld		b,a
 					ret
 


endofdata:
									; where the font is stored, needs to be 0xNN00 256 page boundary
;fontdata	:   equ		0xf000		; THIS number isn't corrupting!
									; f000h = 61440

								; this is the FONT data
	org 0x9500
	
;--------------------------------------------------------------------
;MY FONT.  I spent a long time designing this!  Please appreciate it.
;--------------------------------------------------------------------
fontdata:	defb    2,0,0,0,0,0,0,0,4,32,32,32,64,64,0,128,19,192,192,64,0,0,0,0,6,80,248,80,80,248,80,0,6,32,248,160,248,40,248,32,5,208,208,32,64,64,176,176,6,32,80,32,104,144,144,104,18,128,128,0,0,0,0,0,3,64,128,128,128,128,128,64,3,128,64,64,64,64,64,128,36,160,64,160,0,0,0,0,4,0,0,64,224,64,0,0,147,0,0,0,0,64,64,128,3,0,0,0,192,0,0,0,2,0,0,0,0,0,0,128,4,32,32,64,64,64,128,128,5,96,144,176,208,144,144,96,4,64,192,64,64,64,64,224,5,96,144,16,32,64,128,240,5,96,144,32,16,144,144,96,6,16,48,80,144,248,16,16,5,240,128,224,16,16,144,96,5,32,64,128,224,144,144,96,5,240,16,32,32,64,64,64,5,96,144,96,144,144,144,96,5,96,144,144,112,16,32,64,2,0,0,128,0,0,128,0,147,0,64,0,0,64,64,128,4,0,32,64,128,64,32,0,3,0,0,192,0,192,0,0,4,0,128,64,32,64,128,0,5,96,144,16,32,64,0,64,7,120,148,172,172,184,128,120,6,32,32,80,80,248,136,136,6,224,144,160,208,136,136,240,6,112,136,144,128,128,136,112,6,224,144,136,136,136,144,224,5,240,128,192,128,128,144,240,5,240,128,192,128,128,128,128,7,112,136,144,128,156,136,120,6,144,144,240,144,144,144,144,4,224,64,64,64,64,64,224,5,48,16,16,16,16,144,96,5,144,160,192,160,144,144,144,4,128,128,128,128,128,128,224,6,136,136,216,168,136,136,136,5,144,144,208,176,144,144,144,6,96,144,136,136,136,136,112,5,224,144,144,160,192,128,128,6,96,144,136,168,168,144,104,5,224,144,144,160,224,144,144,5,96,144,64,32,144,144,96,4,224,64,64,64,64,64,64,5,144,144,144,144,144,144,112,6,136,136,136,136,80,80,32,6,136,136,136,168,168,80,80,6,136,136,80,32,80,136,136,6,136,136,80,32,32,64,64,6,240,16,32,64,128,128,240,3,192,128,128,128,128,128,192,4,128,128,64,64,64,32,32,3,192,64,64,64,64,64,192,6,32,112,168,32,32,32,32,3,0,0,0,0,0,0,224,6,48,72,224,64,64,96,216,5,0,0,112,144,144,176,80,5,128,128,224,144,144,208,160,5,0,0,96,144,128,144,96,5,16,16,112,144,144,176,80,5,0,0,96,144,224,128,112,4,96,128,192,128,128,128,128,165,112,144,144,144,112,16,96,4,128,128,192,160,160,160,160,2,128,0,128,128,128,128,128,163,64,64,64,64,64,64,128,4,128,128,160,192,160,160,160,3,128,128,128,128,128,128,64,6,0,0,208,168,168,168,168,4,0,0,192,160,160,160,160,5,0,0,96,144,144,144,96,165,224,144,144,144,224,128,128,165,112,144,144,144,112,16,24,4,0,0,160,192,128,128,128,4,0,0,96,128,64,32,192,4,64,64,224,64,64,64,64,4,0,0,160,160,160,160,96,6,0,0,136,136,80,80,32,6,0,0,136,136,168,168,88,6,0,0,136,80,32,80,136,165,144,144,144,144,112,16,96,6,0,0,248,16,32,64,248,4,96,64,128,64,64,64,96,2,128,128,128,128,128,128,128,4,192,64,32,64,64,64,192,35,192,192,128,0,0,0,0,9,60,66,153,161,153,66,60

            end    32768
